<template>
  <v-container>
    <v-dialog
      scrollable
      v-model="dialogOpen"
      persistent
      :width="900"
      :height="900"
      style="overflow: hidden"
    >
      <div
        class="rounded"
        style="max-height:1300vh, max-width:90vw; overflow:hidden;"
      >
        <div class="white p-1 headerT">
          <div class="header_right">
            <v-item-group dense class="w-100">
              <v-btn
                tile
                class="m-0 p-2 px-4 font-weight-bold w-100"
                depressed
                color="blue-grey lighten-4"
                style="text-transform: none !important"
                @click="cancelDialog()"
              >
                Cancel
              </v-btn>
            </v-item-group>
          </div>
        </div>
        <v-row class="w-63 location-form mt-10 ml-4">
          <v-col>
            <div
              class="wrapper content-block mb-4 border rounded"
              style="width: 600px; box-shadow: 0px 4px 4px rgb(0 0 0 / 25%)"
            >
              <div class="containerTabs">
                <div class="content">
                  <v-card color="basil" flat>
                    <v-card-text
                      style="
                        max-height: 500px;
                        overflow-x: hidden;
                        overflow: auto;
                      "
                    >
                      <v-row
                        class="blue lighten-5 justify-start"
                        style="margin-top: -15px"
                      >
                        <v-col cols="12" class="text-end">
                          <v-btn
                            class="generate-btn"
                            color="primary"
                            depressed
                            @click="generateRuns"
                            :disabled="isGenerateDisabled"
                          >
                            <span
                              class="font-weight-bold"
                              style="text-transform: none !important"
                              >Generate</span
                            >
                          </v-btn>
                          <v-btn text color="primary" @click="onClear">
                            <span
                              class="font-weight-bold"
                              style="text-transform: none !important"
                              >Clear</span
                            >
                          </v-btn>
                        </v-col>
                      </v-row>
                      <v-row>
                        <v-col cols="10">
                          <p class="m-0 text-start d-flex align-items-center">
                            <span class="mx-2 text-secondary font-weight-bold"
                              >Start Time:
                            </span>
                          </p>
                        </v-col>
                        <v-col cols="2" class="justify-content-end text-end">
                          <v-dialog
                            :ref="'from_dialog'"
                            v-model="shuttling.from_menu"
                            fromTime
                            :return-value.sync="fromTime"
                            persistent
                            width="290px"
                          >
                            <template v-slot:activator="{ on, attrs }">
                              <p
                                class="m-0 font-weight-bold text-primary"
                                v-bind="attrs"
                                v-on="on"
                                v-html="timeFromSecondes(fromTime)"
                              ></p>
                            </template>
                            <v-time-picker
                              v-if="shuttling.from_menu"
                              v-model="fromTime"
                              full-width
                            >
                              <v-spacer></v-spacer>
                              <v-btn
                                text
                                color="primary"
                                @click="shuttling.from_menu = false"
                              >
                                Cancel
                              </v-btn>
                              <v-btn
                                text
                                color="primary"
                                @click="saveStartTime(fromTime)"
                              >
                                OK
                              </v-btn>
                            </v-time-picker>
                          </v-dialog>
                        </v-col>
                      </v-row>
                      <v-row>
                        <v-col cols="10">
                          <p class="m-0 text-start d-flex align-items-center">
                            <span class="mx-2 text-secondary font-weight-bold"
                              >End Time:
                            </span>
                          </p>
                        </v-col>

                        <v-col cols="2" class="justify-content-end text-end">
                          <v-dialog
                            :ref="'to_dialog'"
                            v-model="shuttling.to_menu"
                            :return-value.sync="toTime"
                            persistent
                            width="290px"
                          >
                            <template v-slot:activator="{ on, attrs }">
                              <p
                                class="m-0 font-weight-bold text-primary"
                                v-bind="attrs"
                                v-on="on"
                                v-html="timeFromSecondes(toTime)"
                              ></p>
                            </template>
                            <v-time-picker
                              v-if="shuttling.to_menu"
                              v-model="toTime"
                              full-width
                            >
                              <v-spacer></v-spacer>
                              <v-btn
                                text
                                color="primary"
                                @click="shuttling.to_menu = false"
                              >
                                Cancel
                              </v-btn>
                              <v-btn
                                text
                                color="primary"
                                @click="$refs['to_dialog'].save(toTime)"
                              >
                                OK
                              </v-btn>
                            </v-time-picker>
                          </v-dialog>
                        </v-col>
                      </v-row>
                      <v-divider></v-divider>
                      <div>
                        <!-- please write your code here -->
                        <trip-list
                          v-if="rendered"
                          ref="TripList"
                          :fromTime="fromTime"
                          :toTime="toTime"
                        ></trip-list>
                      </div>
                    </v-card-text>
                  </v-card>
                </div>
              </div>
            </div>
          </v-col>
        </v-row>
        <v-row>
          <v-col>
            <div
              class="m-2 border white rounded"
              style="position: relative; z-index: 1; width: 100%"
            >
              <div style="height: 660px">
                <wiot-map :polylines="polylines" :markers="markers" />
              </div>
            </div>
          </v-col>
        </v-row>
      </div>
    </v-dialog>
    <v-row class="text-center">
      <v-col cols="12">
        <v-img
          :src="'https://wiot-fleet-dev.wiot360.com/250280-1669359818508.png'"
          class="my-3"
          contain
          height="200"
        />
      </v-col>
      <v-col class="mb-4">
        <h1 class="display-2 font-weight-bold mb-3">
          Frontend Assessment - Shuttle Task
        </h1>
        <v-btn
          large
          color="primary"
          variant="outlined"
          @click="dialogOpen = true"
        >
          Start
        </v-btn>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import WiotMap from '@/components/WiotMap.vue';
import TripList from './components/TripList';
import { mapGetters, mapMutations, mapActions } from 'vuex';
import { timeFromSecondes } from './shuttlingService';
import moment from 'moment';

export default {
  name: 'shuttling-task',
  components: {
    WiotMap,
    TripList,
  },
  data: () => ({
    dialogOpen: true,
    shuttling: {
      from_menu: false,
      to_menu: false,
    },
    rendered: true,
  }),
  computed: {
    ...mapGetters('config', ['getFromTime', 'getToTime']),
    ...mapGetters('trips', ['getBaseTrip', 'getFirstTrip']),
    isGenerateDisabled() {
      const time1 = moment(this.getFromTime, 'HH:mm');
      const time2 = moment(this.getToTime, 'HH:mm');
      return !time2.isAfter(time1);
    },
    markers() {
      return this.getBaseTrip?.trip?.map(({ station }) => [
        station?.location?.lat,
        station?.location?.lng,
      ]);
    },
    polylines() {
      return this.getBaseTrip?.statistics?.geometry
        ? [this.getBaseTrip.statistics.geometry]
        : [];
    },
    fromTime: {
      get() {
        return this.getFromTime;
      },
      set(val) {
        return this.updateFromTime(val);
      },
    },
    toTime: {
      get() {
        return this.getToTime;
      },
      set(val) {
        return this.updateToTime(val);
      },
    },
  },
  methods: {
    onClear() {
      this.rendered = false;
      this.resetState();
      setTimeout(() => {
        this.rendered = true;
      }, 200);
    },
    ...mapActions(['resetState']),
    ...mapActions('trips', { generate: 'generateRuns' }),
    ...mapMutations('config', ['updateFromTime', 'updateToTime']),
    timeFromSecondes,
    cancelDialog() {
      this.dialogOpen = !this.dialogOpen;
    },
    submitDialog() {
      this.dialogOpen = !this.dialogOpen;
    },

    saveStartTime(time) {
      this.$refs['from_dialog'].save(time);
    },
    generateRuns() {
      // please write your code here
      this.generate();
    },
  },
};
</script>

<style lang="scss">
div .v-dialog {
  box-shadow: none !important;
  // New Addition
  position: relative;
  overflow: hidden;
}

.headerT {
  // Uncommented
  position: absolute;
  right: 0;
  top: 0px;
  border-radius: 50px 0 0 50px;
  z-index: 100;
}

.header_right {
  overflow: hidden;
  border-radius: 50px 0 0 50px;
  min-width: 160px;
}

.header_left {
  // Uncommented
  position: absolute;
  left: 0;
  top: 0px;
  border-radius: 0 50px 50px 0;
  min-width: 100px;
  z-index: 100;

  @media screen and (max-width: 520px) {
    display: none;
  }
}

.header_left_inner {
  border-radius: 0 50px 50px 0;
  overflow: hidden;
}

.generate-btn {
  background-color: '#04092152';
  margin-left: '65px';
  margin-top: '5px';
  color: '#FFFFFF';
  font-weight: '600';
  font-size: '16px';
  line-height: '22px';
}

.location-form {
  position: absolute;
  z-index: 9;
}

.location-form .content-block {
  background-color: rgb(255 255 255 / 69%);
}
</style>
